/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.battle.ai.BattleAIManager
 *  fire.pb.buff.Module
 *  fire.pb.buff.continual.ConstantlyBuff
 *  fire.pb.buff.continual.DecisionBuff
 *  fire.pb.npc.MonsterConfig
 *  fire.pb.option.PAddProtector
 *  fire.pb.school.SchoolConst
 *  fire.pb.skill.Module
 *  fire.pb.skill.SubSkillConfig
 *  fire.pb.skill.fight.FightSkillConfig
 *  fire.pb.util.Misc
 *  fire.script.AbstractJSEngine
 *  mkdb.Procedure
 *  mkio.Protocol
 *  xbean.BattleInfo
 *  xbean.Decision
 *  xbean.Fighter
 *  xbean.HookData
 *  xbean.Monster
 *  xbean.MonsterSkill
 *  xbean.Pod
 *  xtable.Rolehook
 */
package fire.pb.battle;

import fire.pb.battle.BattleField;
import fire.pb.battle.Fighter;
import fire.pb.battle.Monster;
import fire.pb.battle.Operation;
import fire.pb.battle.SSendBattlerOperateState;
import fire.pb.battle.ai.BattleAIManager;
import fire.pb.buff.continual.ConstantlyBuff;
import fire.pb.buff.continual.DecisionBuff;
import fire.pb.npc.MonsterConfig;
import fire.pb.option.PAddProtector;
import fire.pb.school.SchoolConst;
import fire.pb.skill.Module;
import fire.pb.skill.SubSkillConfig;
import fire.pb.skill.fight.FightSkillConfig;
import fire.pb.util.Misc;
import fire.script.AbstractJSEngine;
import java.util.ArrayList;
import java.util.List;
import mkdb.Procedure;
import mkio.Protocol;
import xbean.BattleInfo;
import xbean.Decision;
import xbean.HookData;
import xbean.MonsterSkill;
import xbean.Pod;
import xtable.Rolehook;

public class DecisionProcesser {
    public static void addRoleDecision(BattleInfo battle, Integer index, Operation ro, boolean isauto) {
        if (battle.getDecisions().get(index) != null) {
            return;
        }
        Fighter fighter = (Fighter)battle.getFighterobjects().get(index);
        if (fighter == null) {
            return;
        }
        Decision decision = null;
        DecisionBuff dbuff = fighter.getDecisonBuff();
        if (dbuff != null) {
            decision = dbuff.getDecision();
            if (dbuff.getId() == 501008 && (ro.operationtype == 9 || ro.operationtype == 6 || ro.operationtype == 7)) {
                decision.setAim(ro.aim);
                decision.setOperateid(ro.operationid);
                decision.setOperatetype(ro.operationtype);
                decision.setOperator(index.intValue());
                decision.setIsauto(isauto);
            }
        } else {
            decision = Pod.newDecision();
            decision.setAim(ro.aim);
            decision.setOperateid(ro.operationid);
            decision.setOperatetype(ro.operationtype);
            decision.setOperator(index.intValue());
            decision.setIsauto(isauto);
            if (isauto) {
                BattleField.dealBabyFight(battle, (Fighter)battle.getFighterobjects().get(index), decision, false);
            }
        }
        DecisionProcesser.addDecisionWithSP(battle, decision);
    }

    public static void addPetDecision(BattleInfo battle, Integer index, Operation po, boolean isauto) {
        if (battle.getDecisions().get(index) != null) {
            return;
        }
        if (BattleField.checkOutBattle(battle, index)) {
            return;
        }
        Fighter fighter = (Fighter)battle.getFighterobjects().get(index);
        if (fighter == null) {
            return;
        }
        Decision decision = null;
        decision = Pod.newDecision();
        decision.setAim(po.aim);
        if (po.operationtype == 2 && !fighter.getSkillAgent().hasEffectSkill(po.operationid)) {
            decision.setOperateid(0);
            decision.setOperatetype(1);
        } else {
            decision.setOperateid(po.operationid);
            decision.setOperatetype(po.operationtype);
        }
        decision.setOperator(index.intValue());
        decision.setIsauto(isauto);
        if (isauto) {
            BattleField.dealBabyFight(battle, (Fighter)battle.getFighterobjects().get(index), decision, false);
        }
        DecisionProcesser.addDecisionWithSP(battle, decision);
    }

    public static void setFieldfighterAction(BattleInfo battle) {
        Decision decision = BattleAIManager.getInstance().getDecision(battle, 0);
        DecisionProcesser.addDecisionWithSP(battle, decision);
    }

    public static void setMonsterAction(BattleInfo battle) {
        for (Fighter monsterfighter : battle.getFighterobjects().values()) {
            xbean.Monster xmonster;
            MonsterConfig cfg;
            Decision decision = null;
            if (monsterfighter.getFighterBean().getFightertype() == 1 || monsterfighter.getFighterBean().getFightertype() == 2 || BattleField.checkOutBattle(battle, monsterfighter.getFighterId()) || battle.getDecisions().containsKey(monsterfighter.getFighterId())) continue;
            DecisionBuff dbuff = monsterfighter.getDecisonBuff();
            if (dbuff != null && (decision = dbuff.getDecision()) != null && decision.getOperator() == 0) {
                decision.setOperator(monsterfighter.getFighterId());
            }
            if (decision == null) {
                decision = BattleAIManager.getInstance().getDecision(battle, monsterfighter.getFighterId());
            }
            if (decision == null && (cfg = Monster.getMonsterConfig((xmonster = (xbean.Monster)battle.getMonsters().get(monsterfighter.getFighterId())).getMonsterid())) != null && Misc.checkRate((int)1000, (int)cfg.getRunRate())) {
                decision = Pod.newDecision();
                decision.setOperator(monsterfighter.getFighterId());
                decision.setOperatetype(9);
            }
            if (decision == null) {
                decision = DecisionProcesser.getMonsterRandomDecision(battle, monsterfighter);
            }
            DecisionProcesser.addDecisionWithSP(battle, decision);
        }
    }

    public static Decision getMonsterRandomDecision(BattleInfo battle, Fighter monsterfighter) {
        Decision decision = Pod.newDecision();
        boolean enemyIndex = false;
        xbean.Monster xmonster = (xbean.Monster)battle.getMonsters().get(monsterfighter.getFighterId());
        int[] rates = new int[xmonster.getSkills().size() + 1];
        int i = 0;
        int ratesum = 0;
        int remainrate = 0;
        for (MonsterSkill monsterSkill : xmonster.getSkills()) {
            FightSkillConfig conf = Module.getInstance().getFightSkillConfig(monsterSkill.getId());
            if (!(conf != null && conf.isActiveSkill() && monsterfighter.canAction(2, monsterSkill.getId()) && DecisionProcesser.checkMonsterHpMpConsume(conf, battle, monsterfighter))) {
                rates[i] = 0;
                remainrate += monsterSkill.getCastrate();
            } else {
                rates[i] = monsterSkill.getCastrate();
            }
            ratesum += monsterSkill.getCastrate();
            ++i;
        }
        if (rates.length > 1 && remainrate > 0) {
            float fext = 0.0f;
            if (remainrate != ratesum) {
                fext = remainrate / (ratesum - remainrate);
            }
            for (int rate : rates) {
                if (rate <= 0) continue;
                rate = (int)((float)rate * (1.0f + fext)) + 1;
            }
        }
        rates[xmonster.getSkills().size()] = ratesum > 1000 ? 0 : 1000 - ratesum;
        int chose = Misc.getProbability((int[])rates);
        decision.setOperator(monsterfighter.getFighterId());
        if (chose == -1 || chose == xmonster.getSkills().size()) {
            if (monsterfighter.getFightertype() == 3 && monsterfighter.getBuffAgent().existBuff(502002) && xmonster.getSchool() != SchoolConst.WARRIOR && xmonster.getSchool() != SchoolConst.HUNTER && xmonster.getSchool() != SchoolConst.ROGUE) {
                BattleField.logger.debug((Object)"怪物中了沉默buff，改为防御");
                decision.setOperatetype(4);
                decision.setOperateid(0);
                decision.setAim(monsterfighter.getFighterId());
            } else if (monsterfighter.getFightertype() == 3 && monsterfighter.getBuffAgent().existBuff(502003)) {
                BattleField.logger.debug((Object)"怪物中了定身buff，改为防御");
                decision.setOperatetype(4);
                decision.setOperateid(0);
                decision.setAim(monsterfighter.getFighterId());
            } else {
                decision.setOperatetype(1);
                decision.setOperateid(0);
                decision.setAim(0);
            }
        } else {
            MonsterSkill monsterSkill = (MonsterSkill)xmonster.getSkills().get(chose);
            FightSkillConfig conf = Module.getInstance().getFightSkillConfig(monsterSkill.getId());
            if (!(conf != null && conf.isActiveSkill() && monsterfighter.canAction(2, monsterSkill.getId()) && DecisionProcesser.checkMonsterHpMpConsume(conf, battle, monsterfighter))) {
                if (monsterfighter.getFightertype() == 3 && monsterfighter.getBuffAgent().existBuff(502002) && xmonster.getSchool() != SchoolConst.WARRIOR && xmonster.getSchool() != SchoolConst.HUNTER && xmonster.getSchool() != SchoolConst.ROGUE) {
                    BattleField.logger.debug((Object)"怪物中了沉默buff，改为防御");
                    decision.setOperatetype(4);
                    decision.setOperateid(0);
                    decision.setAim(monsterfighter.getFighterId());
                } else if (monsterfighter.getFightertype() == 3 && monsterfighter.getBuffAgent().existBuff(502003)) {
                    BattleField.logger.debug((Object)"怪物中了定身buff，改为防御");
                    decision.setOperatetype(4);
                    decision.setOperateid(0);
                    decision.setAim(monsterfighter.getFighterId());
                } else {
                    decision.setOperatetype(1);
                    decision.setOperateid(0);
                    decision.setAim(0);
                    BattleField.logger.error((Object)"ai随机选择技能。如果跑到这里填表或程序已经有bug了，请和程序联系!");
                }
            } else {
                decision.setOperatetype(2);
                decision.setOperateid(monsterSkill.getId());
                ArrayList<Integer> buffs = new ArrayList<Integer>();
                buffs.add(506002);
                List<Integer> filterbuffids = BattleField.GetFilterAimsByBuffs(monsterSkill.getId(), buffs);
                decision.setAim(BattleField.getRandTargetByType(battle, monsterfighter.getFighterId(), conf.getType(), false, false, filterbuffids));
            }
        }
        return decision;
    }

    private static boolean processProtectAndDefend(BattleInfo battle, Decision decision) {
        if (decision.getOperatetype() == 5) {
            if (decision.getOperator() == decision.getAim()) {
                return false;
            }
            new PAddProtector(battle.getBattleid(), decision.getOperator(), decision.getAim()).call();
            return true;
        }
        if (decision.getOperatetype() == 4) {
            int result = (Integer)battle.getRoundresult().get(decision.getOperator());
            battle.getRoundresult().put(decision.getOperator(), result | 0x80);
            return true;
        }
        return false;
    }

    private static void addInitiveSkillSpeed(BattleInfo battle, Decision decision) {
        if (decision.getOperatetype() != 2) {
            return;
        }
        FightSkillConfig sconf = Module.getInstance().getFightSkillConfig(decision.getOperateid());
        if (sconf == null || sconf.getSpeedBonus() == 0) {
            return;
        }
        ConstantlyBuff cbuff = fire.pb.buff.Module.getInstance().createConstantlyBuff(500015);
        cbuff.getEffects().put(201, Float.valueOf(sconf.getSpeedBonus()));
        Fighter fighter = (Fighter)battle.getFighterobjects().get(decision.getOperator());
        if (fighter != null) {
            fighter.getBuffAgent().addCBuff(cbuff);
        }
    }

    public static boolean checkMonsterHpMpConsume(FightSkillConfig skillConfig, BattleInfo battle, Fighter opfighter) {
        try {
            SubSkillConfig subSkill;
            Double epconsume;
            int spconsume;
            Double hpconsume;
            if (battle.getRound() < 3 && skillConfig.getHpConsumeJavaScript().GetDoubleValue() == null) {
                return true;
            }
            if (opfighter == null) {
                return false;
            }
            battle.getEngine().setSkillLevel(opfighter.getSkillAgent().getLevel(skillConfig.getSkillIndex()));
            battle.getEngine().setOpFighter(opfighter, skillConfig.getUsedAttrTypea());
            battle.getEngine().setSkillTargetNum(1);
            Double mpconsume = skillConfig.getMpConsumeJavaScript().eval((AbstractJSEngine)battle.getEngine(), opfighter, null);
            if (mpconsume > (double)opfighter.getEffectRole().getMp()) {
                return false;
            }
            if (battle.getBattletype() % 10 == 1 && skillConfig.getIsOnlyPve()) {
                return false;
            }
            if (skillConfig.getHpConsumeJavaScript() != null && (hpconsume = skillConfig.getHpConsumeJavaScript().eval((AbstractJSEngine)battle.getEngine(), opfighter, null)) >= (double)opfighter.getEffectRole().getHp()) {
                return false;
            }
            if (skillConfig.getSpConsumeJavaScript() != null && (spconsume = skillConfig.getSpConsumeJavaScript().eval((AbstractJSEngine)battle.getEngine(), opfighter, null).intValue()) > opfighter.getEffectRole().getSp()) {
                return false;
            }
            if (skillConfig.getEpConsumeJavaScript() != null && opfighter.getFighterBean() != null && opfighter.getFighterBean().getInitattrs() != null && (epconsume = skillConfig.getEpConsumeJavaScript().eval((AbstractJSEngine)battle.getEngine(), opfighter, null)) > (double)((Float)opfighter.getFighterBean().getInitattrs().get(1010)).floatValue()) {
                return false;
            }
            return skillConfig.getSubSkills() == null || skillConfig.getSubSkills().length <= 0 || (subSkill = skillConfig.getSubSkills()[0]).getConfilictStateJs().evalToBoolean((AbstractJSEngine)battle.getEngine(), opfighter, null) != false;
        }
        catch (Exception e) {
            BattleField.logger.error((Object)e);
            return false;
        }
    }

    private static void addDecisionWithSP(BattleInfo battle, Decision decision) {
        if (decision == null) {
            return;
        }
        battle.getDecisions().put(decision.getOperator(), decision);
        DecisionProcesser.processProtectAndDefend(battle, decision);
        DecisionProcesser.addInitiveSkillSpeed(battle, decision);
        xbean.Fighter xfighter = (xbean.Fighter)battle.getFighters().get(decision.getOperator());
        if (xfighter == null || xfighter.getFightertype() >= 3) {
            return;
        }
        SSendBattlerOperateState snd = new SSendBattlerOperateState(decision.getOperator(), 2);
        Procedure.psendWhileCommit(battle.getRoleids().keySet(), (Protocol)snd);
    }

    public static Decision getDefaultDecision(BattleInfo battle, xbean.Fighter fighter) {
        Decision d = Pod.newDecision();
        d.setOperator(fighter.getBattleindex());
        d.setAim(0);
        if (fighter.getFightertype() == 1) {
            HookData hookData = Rolehook.get((Long)fighter.getUniqueid());
            if (hookData == null) {
                d.setOperatetype(1);
            } else {
                d.setOperatetype((int)hookData.getCharoptype());
                d.setOperateid(hookData.getCharopid());
            }
        } else if (fighter.getFightertype() == 1) {
            HookData hookData = Rolehook.get((Long)fighter.getUniqueid());
            if (hookData == null) {
                d.setOperatetype(1);
            } else {
                d.setOperatetype((int)hookData.getPetoptype());
                d.setOperateid(hookData.getPetopid());
            }
        } else {
            d.setOperatetype(1);
        }
        return d;
    }

    public static Operation getDefaultOperation() {
        Operation operation = new Operation();
        operation.operationtype = 1;
        operation.aim = 0;
        operation.operationid = 0;
        return operation;
    }

    public static Operation getRoleDefaultOperation(long roleId) {
        Operation operation = new Operation();
        HookData hookData = Rolehook.get((Long)roleId);
        if (hookData == null) {
            operation.operationtype = 1;
            operation.aim = 0;
            operation.operationid = 0;
        } else {
            operation.operationtype = hookData.getCharoptype();
            operation.aim = 0;
            operation.operationid = hookData.getCharopid();
        }
        return operation;
    }

    public static Operation getPetDefaultOperation(long roleId) {
        Operation operation = new Operation();
        HookData hookData = Rolehook.get((Long)roleId);
        if (hookData == null) {
            operation.operationtype = 1;
            operation.aim = 0;
            operation.operationid = 0;
        } else {
            operation.operationtype = hookData.getPetoptype();
            operation.aim = 0;
            operation.operationid = hookData.getPetopid();
        }
        return operation;
    }
}

